package myutil;

import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Vector;

import enumerate.Action;
import enumerate.State;
import struct.MotionData;

enum GameState {
	AIR, Ground, HAME, NEAR, FAR
}// これの値で学習時とかもろもろ影響するので注意

public class My {
	// ながさがGameState.values().lengthになってないとダメ
	public static final boolean[] isAirtable = new boolean[] { true, false, false, false, false };

	// static final String nowForWrite="data/aiData/SerialTrain/now1.dat";
	public static final String dataDirectoryPath = "../FightingICEver.3.10/data/aiData/GigaThunder/";

	public static final String logPointPath = "../FightingICEver.3.10/log/point/";
	public static final Action[] actionAir = new Action[] { Action.AIR_GUARD, Action.AIR_A, Action.AIR_B, Action.AIR_DA,
			Action.AIR_DB, Action.AIR_FA, Action.AIR_FB, Action.AIR_UA, Action.AIR_UB, Action.AIR_D_DF_FA,
			Action.AIR_D_DF_FB, Action.AIR_F_D_DFA, Action.AIR_F_D_DFB, Action.AIR_D_DB_BA, Action.AIR_D_DB_BB };
	public static final Action[] actionGround = new Action[] { Action.STAND_D_DB_BA, Action.BACK_STEP,
			Action.FORWARD_WALK, Action.DASH, Action.JUMP, Action.FOR_JUMP, Action.BACK_JUMP, Action.STAND_GUARD,
			Action.CROUCH_GUARD, Action.THROW_A, Action.THROW_B, Action.STAND_A, Action.STAND_B, Action.CROUCH_A,
			Action.CROUCH_B, Action.STAND_FA, Action.STAND_FB, Action.CROUCH_FA, Action.CROUCH_FB, Action.STAND_D_DF_FA,
			Action.STAND_D_DF_FB, Action.STAND_F_D_DFA, Action.STAND_F_D_DFB, Action.STAND_D_DB_BB,
			Action.STAND_D_DF_FC };

	public static final Action[] actionAirNonEnergy = new Action[] { Action.AIR_GUARD, Action.AIR_A, Action.AIR_B,
			Action.AIR_DB, Action.AIR_FA, Action.AIR_FB, Action.AIR_UA, Action.AIR_UB, Action.AIR_D_DF_FA, };
	public static final Action[] actionGroundNonEnergy = new Action[] { Action.STAND_D_DB_BA, Action.BACK_STEP,
			Action.FORWARD_WALK, Action.DASH, Action.JUMP, Action.FOR_JUMP, Action.BACK_JUMP, Action.STAND_GUARD,
			Action.CROUCH_GUARD, Action.STAND_A, Action.STAND_B, Action.CROUCH_A, Action.CROUCH_B, Action.STAND_FA,
			Action.STAND_FB, Action.CROUCH_FA, Action.CROUCH_FB, Action.STAND_F_D_DFA, Action.STAND_D_DB_BB };

	// public static final Action[] actionGroundNonEnergyPlusSlider =
	// new Action[] {Action.STAND_D_DB_BA, Action.BACK_STEP,
	// Action.FORWARD_WALK, Action.DASH,
	// Action.JUMP, Action.FOR_JUMP, Action.BACK_JUMP, Action.STAND_GUARD,
	// Action.CROUCH_GUARD, Action.STAND_A, Action.STAND_B,
	// Action.CROUCH_A, Action.CROUCH_B, Action.STAND_FA, Action.STAND_FB,
	// Action.CROUCH_FA,
	// Action.CROUCH_FB, Action.STAND_D_DF_FA, Action.STAND_F_D_DFA,
	// Action.STAND_D_DB_BB};

	/**** ZEN ***/

	public static final Action[] ZenFinalActionAir = // 20 3.3759618E7
			new Action[] { Action.AIR_GUARD, Action.AIR_A, Action.AIR_B, Action.AIR_DB, Action.AIR_FA, Action.AIR_FB,
					Action.AIR_UA, Action.AIR_UB, Action.AIR_D_DF_FA, Action.AIR_DA, Action.AIR_F_D_DFB };
	public static final Action[] ZenFinalActionGround = new Action[] { Action.BACK_STEP, Action.DASH, Action.JUMP,
			Action.FOR_JUMP, Action.BACK_JUMP, Action.STAND_GUARD, Action.CROUCH_GUARD, Action.STAND_D_DB_BA,
			Action.CROUCH_A, Action.CROUCH_B, Action.FORWARD_WALK, Action.THROW_A, Action.CROUCH_FB,
			Action.STAND_F_D_DFA, Action.STAND_D_DB_BB, };

	public static final Action[] ZenFinalActionHame = new Action[] { Action.FORWARD_WALK, Action.STAND,
			Action.CROUCH_FB, Action.STAND_B, Action.STAND_D_DF_FC };

	public static final Action[] ZenFinalActionNear = new Action[] { Action.FORWARD_WALK, Action.DASH,
			Action.STAND_D_DB_BB, Action.STAND_B, Action.STAND_D_DF_FC };

	public static final Action[] ZenFinalActionFar = new Action[] { Action.FORWARD_WALK, Action.DASH,
			Action.STAND_D_DB_BB, Action.FOR_JUMP, Action.STAND_D_DF_FC };

	public static final Action[] ZenMustActionAir = new Action[] {};

	public static final Action[] ZenMustActionGround = new Action[] { Action.DASH, Action.FOR_JUMP,
			Action.STAND_D_DB_BA, Action.CROUCH_FB, Action.STAND_D_DF_FC };

	public static final Action[] ZenMustActionHame = new Action[] { Action.STAND_D_DB_BA, Action.CROUCH_FB,
			Action.STAND_D_DF_FC };
	public static final Action[] ZenMustActionFar = new Action[] { Action.FOR_JUMP, Action.STAND_D_DB_BA,
			Action.STAND_D_DF_FC };

	/**** Garnet ***/

	public static final Action[] NormalGarnetFinalActionAir = new Action[] { Action.AIR_GUARD, Action.AIR_DB,
			Action.AIR_FA, Action.AIR_FB, Action.AIR_UA, Action.AIR_D_DF_FB, Action.AIR_F_D_DFB, };

	public static final Action[] NormalGarnetFinalActionGround = new Action[] { Action.DASH, Action.FOR_JUMP,
			Action.STAND_D_DF_FC, Action.BACK_STEP, Action.JUMP, Action.THROW_A, Action.CROUCH_B, Action.STAND_D_DF_FA,
			Action.STAND_D_DF_FB, Action.STAND_F_D_DFA, };

	public static final Action[] NormalGarnetFinalActionHame = new Action[] { Action.DASH, Action.FOR_JUMP,
			Action.STAND_D_DF_FC, Action.STAND_D_DB_BA, Action.FORWARD_WALK, Action.CROUCH_GUARD, Action.CROUCH_A,
			Action.CROUCH_B, Action.STAND_FA, Action.STAND_FB, Action.CROUCH_FA, Action.CROUCH_FB, Action.STAND_D_DF_FA,
			Action.STAND_D_DF_FB, Action.STAND_F_D_DFA, Action.STAND_F_D_DFB, Action.STAND_D_DB_BB, };

	public static final Action[] NormalGarnetFinalActionNear = new Action[] { Action.DASH, Action.FOR_JUMP,
			Action.STAND_D_DF_FC, Action.STAND_D_DB_BA, Action.BACK_JUMP, Action.STAND_GUARD, Action.STAND_A,
			Action.STAND_B, Action.CROUCH_B, Action.STAND_FB, Action.CROUCH_FA, Action.STAND_D_DF_FA,
			Action.STAND_D_DF_FB, Action.STAND_F_D_DFB, };

	public static final Action[] NormalGarnetFinalActionFar = new Action[] { Action.DASH, Action.FOR_JUMP,
			Action.STAND_D_DF_FC, Action.BACK_STEP, Action.FORWARD_WALK, Action.JUMP, Action.BACK_JUMP,
			Action.STAND_GUARD, Action.THROW_A, Action.THROW_B, Action.STAND_A, Action.CROUCH_A, Action.CROUCH_B,
			Action.STAND_FA, Action.STAND_FB, Action.CROUCH_FB, Action.STAND_D_DF_FA, Action.STAND_F_D_DFB, };

	public static final Action[] SpeedGarnetFinalActionAir = new Action[] { Action.AIR_DA, Action.AIR_DB, Action.AIR_FA,
			Action.AIR_FB, Action.AIR_UA, Action.AIR_D_DF_FA, Action.AIR_D_DF_FB, Action.AIR_F_D_DFA,
			Action.AIR_F_D_DFB, Action.AIR_D_DB_BB, };

	public static final Action[] SpeedGarnetFinalActionGround = new Action[] { Action.DASH, Action.FOR_JUMP,
			Action.STAND_D_DF_FC, Action.BACK_STEP, Action.FORWARD_WALK, Action.JUMP, Action.CROUCH_GUARD,
			Action.THROW_B, Action.STAND_A, Action.STAND_B, Action.CROUCH_A, Action.STAND_F_D_DFB, };

	public static final Action[] SpeedGarnetFinalActionHame = new Action[] { Action.DASH, Action.FOR_JUMP,
			Action.STAND_D_DF_FC, Action.STAND_D_DB_BA, Action.FORWARD_WALK, Action.CROUCH_GUARD, Action.THROW_B,
			Action.STAND_B, Action.CROUCH_A, Action.CROUCH_B, Action.CROUCH_FA, Action.CROUCH_FB, Action.STAND_D_DF_FA,
			Action.STAND_D_DB_BB, };

	public static final Action[] SpeedGarnetFinalActionNear = new Action[] { Action.DASH, Action.FOR_JUMP,
			Action.STAND_D_DF_FC, Action.STAND_D_DB_BA, Action.BACK_STEP, Action.FORWARD_WALK, Action.JUMP,
			Action.BACK_JUMP, Action.CROUCH_GUARD, Action.THROW_B, Action.STAND_A, Action.CROUCH_A, Action.CROUCH_B,
			Action.CROUCH_FA, Action.STAND_D_DF_FA, Action.STAND_D_DF_FB, };

	public static final Action[] SpeedGarnetFinalActionFar = new Action[] { Action.DASH, Action.FOR_JUMP,
			Action.STAND_D_DF_FC, Action.BACK_STEP, Action.STAND_GUARD, Action.THROW_B, Action.STAND_B, Action.CROUCH_B,
			Action.STAND_FA, Action.STAND_FB, Action.STAND_D_DF_FA, };

	public static final Action[] GarnetMustActionAir = new Action[] {};

	public static final Action[] GarnetMustActionGround = new Action[] { Action.DASH, Action.FOR_JUMP,
			Action.STAND_D_DF_FC };

	/***** AllCharacter ***/

	// 横幅がGameState.values().lengthになってないとダメ
	public static final Action[][][][] FinalAction = new Action[][][][] {
			new Action[][][] { new Action[][] { actionAir, actionGround }, new Action[][] { actionAir, actionGround },
					new Action[][] { actionAir, actionGround }, },
			new Action[][][] {
					new Action[][] { ZenFinalActionAir, ZenFinalActionGround, ZenFinalActionHame, ZenFinalActionNear,
							ZenFinalActionFar },
					new Action[][] { SpeedGarnetFinalActionAir, SpeedGarnetFinalActionGround,
							SpeedGarnetFinalActionHame, SpeedGarnetFinalActionNear, SpeedGarnetFinalActionFar },
					new Action[][] { actionAir, actionGround, actionGround, actionGround, actionGround }

			} };

	public static final Action[][][][] MustAction = new Action[][][][] {
			new Action[][][] {
					// normalmode
					new Action[][] { ZenMustActionAir, ZenMustActionGround, ZenMustActionHame, ZenMustActionFar,
							ZenMustActionFar },
					new Action[][] { GarnetMustActionAir, GarnetMustActionGround, GarnetMustActionGround,
							GarnetMustActionGround, GarnetMustActionGround }, },
			// speedmode
			new Action[][][] {
					new Action[][] { ZenMustActionAir, ZenMustActionGround, ZenMustActionHame, ZenMustActionFar,
							ZenMustActionFar },
					new Action[][] { GarnetMustActionAir, GarnetMustActionGround, GarnetMustActionGround,
							GarnetMustActionGround, GarnetMustActionGround }, }, };

	public static void ls(String path) {
		File dir = new File(path);
		File[] files = dir.listFiles();
		for (int i = 0; i < files.length; i++) {
			File file = files[i];
			System.out.println(file.getName());
		}
	}

	static Action[] getGaAction(Action[] MustAction, boolean isAir) {
		Action[] allAction;
		if (isAir)
			allAction = actionAir;
		else
			allAction = actionGround;
		ArrayList<Action> ac = new ArrayList<Action>(Arrays.asList(allAction.clone()));
		for (int i = ac.size() - 1; i >= 0; i--) {

			for (int j = 0; j < MustAction.length; j++) {
				if (MustAction[j] == ac.get(i)) {
					ac.remove(i);
				}
			}

		}

		return ac.toArray(new Action[0]);
	}

	// 使いたいアクションだけひっぱってくる あんまり強くないかも。。ボツ
	static ArrayList<Action> getUseAction(Vector<MotionData> motions, Action[] allaction) {
		ArrayList<Action> ac = new ArrayList<Action>();
		for (int i = 0; i < allaction.length; i++) {
			MotionData motion = motions.elementAt(Action.valueOf(allaction[i].name()).ordinal());
			if (motion.getAttackStartAddEnergy() >= 0 || // 無料のアクション
					(motion.isAttackDownProp() && motion.speedX > 0) || // ダウンさせるアクション
					((motion.attackSpeedX != 0) && (motion.state == State.STAND)) || // 地上波動拳
					(motion.attackType == 4)// 投げ
			)
				ac.add(allaction[i]);

		}
		return ac;
	}

}
